function init(a,b)
local array = {}
for i = 1, a do
array[i] = b
end
return array
end

bvp.state=init(32,false)
bvp.type=init(32,0)
bvp.x=init(32,0)
bvp.y=init(32,0)
bvp.img=init(32,"")
bvp.page=init(32,0)

addhook("always","bvp.Always")
addhook("serveraction","bvp.SAction")
addhook("menu","bvp.Menu")
addhook("die","bvp.Die")

function bvp.Always()
	for id=1,32 do
		if player(id,"exists") then
			if bvp.state[id] then
				local t,x,y= bvp.type[id], bvp.x[id], bvp.y[id]
				local dist = math.sqrt((player(id,"x")-x)^2 + (player(id,"y")-y)^2)
				if dist>32 then
					local a = -math.deg(math.atan2(x-player(id,"x"),y-player(id,"y")))
					local s, c = -math.sin(math.rad(a+180))*bvp.petlist[t].spd/4, math.cos(math.rad(a+180))*bvp.petlist[t].spd/4
					if tile(math.floor((x+s)/32),math.floor((y+c)/32),"walkable") then
						bvp.x[id]=x+s
						bvp.y[id]=y+c
						imagepos(bvp.img[id],bvp.x[id],bvp.y[id],a)
					else
						if a>0 and a<90 then					
							local s, c = -math.sin(math.rad(0+180))*bvp.petlist[t].spd/4, math.cos(math.rad(0+180))*bvp.petlist[t].spd/4
							if tile(math.floor((x+s)/32),math.floor((y+c)/32),"walkable") then
								bvp.x[id]=x+s
								bvp.y[id]=y+c
								imagepos(bvp.img[id],bvp.x[id],bvp.y[id],a)
							else
								local s, c = -math.sin(math.rad(90+180))*bvp.petlist[t].spd/4, math.cos(math.rad(90+180))*bvp.petlist[t].spd/4								bvp.x[id]=x+s
								bvp.y[id]=y+c
								bvp.x[id]=x+s
								imagepos(bvp.img[id],bvp.x[id],bvp.y[id],a)
							end
						end
						if a>90 and a<180 then					
							local s, c = -math.sin(math.rad(90+180))*bvp.petlist[t].spd/4, math.cos(math.rad(90+180))*bvp.petlist[t].spd/4
							if tile(math.floor((x+s)/32),math.floor((y+c)/32),"walkable") then
								bvp.x[id]=x+s
								bvp.y[id]=y+c
								imagepos(bvp.img[id],bvp.x[id],bvp.y[id],a)
							else
								local s, c = -math.sin(math.rad(180+180))*bvp.petlist[t].spd/4, math.cos(math.rad(180+180))*bvp.petlist[t].spd/4								bvp.x[id]=x+s
								bvp.y[id]=y+c
								bvp.x[id]=x+s
								imagepos(bvp.img[id],bvp.x[id],bvp.y[id],a)
							end
						end
						if a<0 and a>-90 then					
							local s, c = -math.sin(math.rad(0+180))*bvp.petlist[t].spd/4, math.cos(math.rad(0+180))*bvp.petlist[t].spd/4
							if tile(math.floor((x+s)/32),math.floor((y+c)/32),"walkable") then
								bvp.x[id]=x+s
								bvp.y[id]=y+c
								imagepos(bvp.img[id],bvp.x[id],bvp.y[id],a)
							else
								local s, c = -math.sin(math.rad(-90+180))*bvp.petlist[t].spd/4, math.cos(math.rad(-90+180))*bvp.petlist[t].spd/4								bvp.x[id]=x+s
								bvp.y[id]=y+c
								bvp.x[id]=x+s
								imagepos(bvp.img[id],bvp.x[id],bvp.y[id],a)
							end
						end
						if a<-90 and a>-180 then
							local s, c = -math.sin(math.rad(-90+180))*bvp.petlist[t].spd/4, math.cos(math.rad(-90+180))*bvp.petlist[t].spd/4
							if tile(math.floor((x+s)/32),math.floor((y+c)/32),"walkable") then
								bvp.x[id]=x+s
								bvp.y[id]=y+c
								imagepos(bvp.img[id],bvp.x[id],bvp.y[id],a)
							else
								local s, c = -math.sin(math.rad(-180+180))*bvp.petlist[t].spd/4, math.cos(math.rad(-180+180))*bvp.petlist[t].spd/4								bvp.x[id]=x+s
								bvp.y[id]=y+c
								bvp.x[id]=x+s
								imagepos(bvp.img[id],bvp.x[id],bvp.y[id],a)
							end
						end
					end
					for id2=1,32 do
						if player(id2,"exists") then
							if id~=id2 and player(id,"team")~=player(id2,"team") then
								local dist2 = math.sqrt((bvp.x[id]-player(id2,"x"))^2 + (bvp.y[id]-player(id2,"y"))^2)
								if dist2<=bvp.petlist[t].range then
									local a = -math.deg(math.atan2(x-player(id2,"x"),y-player(id2,"y")))
									local s, c = -math.sin(math.rad(a+180))*(bvp.petlist[t].spd+4)/4, math.cos(math.rad(a+180))*(bvp.petlist[t].spd+4)/4
									bvp.x[id]=x
									bvp.y[id]=y
									imagepos(bvp.img[id],bvp.x[id],bvp.y[id],a)
									if tile(math.floor((x+s)/32),math.floor((y+c)/32),"walkable") and dist2>5 then
										bvp.x[id]=x+s
										bvp.y[id]=y+c
										imagepos(bvp.img[id],bvp.x[id],bvp.y[id],a)
									end
									if dist2<32 then
										if player(id2,"health")<bvp.petlist[t].dmg then
											parse('customkill '..id..' "(PET) '..bvp.petlist[t].name..'" '..id2)
										else
											parse("sethealth "..id2.." "..player(id2,"health")-bvp.petlist[t].dmg/50)
											local rr=math.random(1,1000)
											if rr<334 then
												parse('effect "smoke" '..player(id2,'x')..' '..player(id2,'y')..' 1 1')
											end
										end
									end
								end
							end
						end
					end
				end
			end
		end
	end
end

function bvp.petmenu(id)
	local p=bvp.page[id]
	for sid=math.ceil(p*6)+1,math.ceil(p*6)+6 do
		if bvp.petlist[sid]==nil then
			bvp.petlist[sid]={name="",cost=""}
		end
	end
	menu(id,"Select PET "..(p+1).." / "..math.ceil(#bvp.petlist/6)..","..bvp.petlist[math.ceil(p*6)+1].name.."|$"..bvp.petlist[math.floor(p*6)+1].cost..","..bvp.petlist[math.ceil(p*6)+2].name.."|$"..bvp.petlist[math.floor(p*6)+2].cost..","..bvp.petlist[math.ceil(p*6)+3].name.."|$"..bvp.petlist[math.floor(p*6)+3].cost..","..bvp.petlist[math.ceil(p*6)+4].name.."|$"..bvp.petlist[math.floor(p*6)+4].cost..","..bvp.petlist[math.ceil(p*6)+5].name.."|$"..bvp.petlist[math.floor(p*6)+5].cost..","..bvp.petlist[math.ceil(p*6)+6].name.."|$"..bvp.petlist[math.floor(p*6)+6].cost..",,Previous,Next")
end

function bvp.SAction(id,bt)
	if bt==bvp.button then
		bvp.petmenu(id)
	end
end

function bvp.Menu(id,title,bt)
	local p=bvp.page[id]
	if title=="Select PET "..(p+1).." / "..math.ceil(#bvp.petlist/6) then
		if bt<=6 and bt>=1 then
			if not bvp.state[id] then
				if player(id,"money")>=bvp.petlist[math.ceil(p*6)+bt].cost then
					bvp.type[id]=math.ceil(p*6)+bt
					local t=bvp.type[id]
					bvp.x[id]=player(id,"x")
					bvp.y[id]=player(id,"y")
					bvp.state[id]=true
					bvp.img[id]=image(bvp.petlist[t].imgpath,bvp.x[id],bvp.y[id],0)
					msg2(id,"Your pet is now "..bvp.petlist[t].name..".")
					parse("setmoney "..id.." "..player(id,"money")-bvp.petlist[t].cost)
				else
					msg2(id,"You dont have enough money.")
				end
			else
				msg2(id,"You have pet already, wait after you die.")
			end
		end
		if bt==8 then
			if p~=0 then
				bvp.page[id]=bvp.page[id]-1
			end
			bvp.petmenu(id)
		end
		if bt==9 then
			if p~=math.ceil(#bvp.petlist/6)-1 then
				bvp.page[id]=bvp.page[id]+1
			end
			bvp.petmenu(id)
		end
	end
end

function bvp.Die(id)
	if bvp.state[id] then
		bvp.state[id]=false
		freeimage(bvp.img[id])
	end
end